function maxima = find_maxima(part,val,limit,offset_r,xp,angles,thadd)
  
   plot_im = 0;
  
   part = (part>val).*part;
  
   if plot_im
     figure(43)
     imagesc(part)
     axis image
   end
   
   [m,t] = max(max(part));
   [s,r] = max(part(:,t));
   
   bwp = bwlabel(part > m-limit);
   part = (part>m-limit).*part;

   if plot_im
     figure(44)
     subplot(2,1,1)
     imagesc(bwp)
     axis image
     subplot(2,1,2)
     imagesc(part)
     axis image
   
     if max(max(bwp))>1
       pause
     end

   end

   
   maxima = [];
   
   if(m ~= 0)
     
     for k=1:max(max(bwp))
       
       [X,Y] = find(bwp==bwp(r,t));
       rt = round(mean(X));
       tt  = round(mean(Y));
       
       r1 = xp(rt+offset_r);
       th1 = angles(tt)*(pi/180); %i radianer
       
       r2 = r1/sin(th1); %skärningen med y       
       
       x2 = abs(r1) * cos(th1);
       y2 = abs(r1) * sin(th1);
       
       x3 = x2 * thadd;
       y3 = y2;
       
       th2 = atan2(y3, x3);
       rr = r1 / cos(th1 - pi/2) * cos(th2 - pi/2);
       
       %m = maximat, r2 = radien där x=0 och th2 nya vinkeln
       maxima(:,k)=[m r2 th2]'; 
       
       part(bwp==bwp(r,t))=0;
       bwp(bwp==bwp(r,t))=0;
       
       [m,t] = max(max(part));
       [s,r] = max(part(:,t));
       
     end
   end
   
