function tracking(vol,x,y,z)
% vol(y,x,z) definition av x,y,z
% 
%
% Ursprungligen av Maria Axelsson
% Redigerad av Erik Wernersson

vol = vol-100;
vol = vol/10;
vol(vol>1)=1;
vol(vol<0)=0;

plot_im = 1;
step_through = 1;

startslice = 150; %11
seed_z(1,:) = [180 200];
seed_x(1,:) = [180 200];


%Padding for the different directions
slicepad = 5; 
pad = 7; %if possible update with fibre thickness

tstep = 2; %timestep

angles = [30:160]; %angles for the radon transform

%F�r alla lablade fibrer
for n = 1:size(seed_x,1)
  
  track = 1;
  
  rh = seed_x(n,2)-seed_x(n,1)+2*pad;
  rb = seed_z(n,2)-seed_z(n,1)+2*pad;
  
  mv = [startslice;  
        mean([seed_x(n,1) seed_x(n,2)]);
        mean([seed_z(n,1) seed_z(n,2)])];
  
  V = [1;0;0];

  
  V_tot = V;
  mv_tot = mv;
  rb_tot = rb;
  rh_tot = rh;
  
  m1_tot = [-1];
  m2_tot = [-1];
  m3_tot = [-1];
  m4_tot = [-1];
  
  m5_tot = [-1];
  m6_tot = [-1];
  m7_tot = [-1];
  m8_tot = [-1];
  
  r1_est = [-1];
  r2_est = [-1];
  r3_est = [-1];
  r4_est = [-1]; 

  nstep = 0;
  
  while (track == 1)
    
    nstep = nstep + 1;
    
    disp(['Slice position mv: ' num2str(mv(1)) ', ' num2str(mv(2)) ...
          ', '  num2str(mv(3))]);
    
    sp = 5; %extra avsmalnad profiltracking???
        
    V = V./norm(V,2);
    
    if(V(1)<=10*eps & V(2)<=10*eps)
      xprim = [-1;1;0];
      zprim = [-1;-1;0];
    else
      xprim = cross([0;0;1],V);
      zprim = cross(V,xprim);
    end

    xprim = xprim./norm(xprim,2);
    zprim = zprim./norm(zprim,2);
    
     
    vp = [-slicepad:slicepad];
    rest = max([rb,rh]);
    xp = [1:rest]-round(rest/2);
    zp = [1:rest]-round(rest/2);
    
    %vp = [-slicepad:slicepad];
    %xp = [1:rh]-round(rh/2);
    %zp = [1:rb]-round(rb/2);


    
    [Vp,Xp,Zp] = ndgrid(vp,xp,zp);
    
    
    B = [V xprim zprim]
    
    volBsmall = [Vp(:)';Xp(:)';Zp(:)'];
    
    volBimage = B*volBsmall+repmat(mv,1,size(volBsmall,2));
    
    sV = size(Xp,1);
    sX = size(Xp,2);
    sZ = size(Xp,3);
    
    Vi = reshape(volBimage(1,:),[sV sX sZ]);
    Xi = reshape(volBimage(2,:),[sV sX sZ]);
    Zi = reshape(volBimage(3,:),[sV sX sZ]);
    
    cpmin = [min(min(min(Vi))),min(min(min(Xi))), ...
             min(min(min(Zi)))];
    cpmin = floor(cpmin);
    cpmax = [max(max(max(Vi))),max(max(max(Xi))),max(max(max(Zi)))];
    cpmax = ceil(cpmax);
    
    if (~isempty(find(Vi>=size(vol,1))) | ~isempty(find(Xi>=size(vol,2))) ...
        | ~isempty(find(Zi>=size(vol,3))))
      track = 0;
      disp('Box hit border. End of volume.');
      break;
    end
        
    intpvol = double(vol(cpmin(1):cpmax(1),cpmin(2):cpmax(2),cpmin(3):cpmax(3)));
    
    minvol = interp3(intpvol,Xi-cpmin(2)+1,Vi-cpmin(1)+1,Zi-cpmin(3)+1);
    
    out1 = rot90(squeeze(sum(minvol(:,1+pad+sp:end-pad-sp,:),2)));
    out2 = rot90(squeeze(sum(minvol(:,:,1+pad+sp:end-pad-sp),3)));
    
    thadd = 4;
    
    %g�r bilden mer OK f�r att k�ra radontransformen p� f�r att uppt�cka alla vinklar.
    out1 = repmat(out1,thadd,1);
    out1 = reshape(out1,size(out1,1)/thadd,size(out1,2)*thadd);
    
    out2 = repmat(out2,thadd,1);
    out2 = reshape(out2,size(out2,1)/thadd,size(out2,2)*thadd);
    
    %normering med max, ok? borde normeras med antal summerade pixlar el likn?
    out1 = out1./max(max(out1));
    out2 = out2./max(max(out2));

    
    %rotera 45 grader
    theta = pi/4; %pi/4
    Brot = B*[1          0          0         ;
              0     cos(theta)   -sin(theta)  ;
              0     sin(theta)    cos(theta)] ;
    
    volBimage = Brot*volBsmall+repmat(mv,1,size(volBsmall,2));
    
    sV = size(Xp,1);
    sX = size(Xp,2);
    sZ = size(Xp,3);
    
    Vi = reshape(volBimage(1,:),[sV sX sZ]);
    Xi = reshape(volBimage(2,:),[sV sX sZ]);
    Zi = reshape(volBimage(3,:),[sV sX sZ]);
    
    cpmin = [min(min(min(Vi))),min(min(min(Xi))), ...
             min(min(min(Zi)))];
    cpmin = floor(cpmin);
    cpmax = [max(max(max(Vi))),max(max(max(Xi))),max(max(max(Zi)))];
    cpmax = ceil(cpmax);
    
    if (~isempty(find(Vi>=size(vol,1))) | ~isempty(find(Xi>=size(vol,2))) ...
        | ~isempty(find(Zi>=size(vol,3))))
      track = 0;
      disp('Box hit border. End of volume.');
      break;
    end
    
    intpvol = double(vol(cpmin(1):cpmax(1),cpmin(2):cpmax(2),cpmin(3):cpmax(3)));
    
    minvol2 = trilinear(intpvol, Xi-cpmin(2)+1,Vi-cpmin(1)+1,Zi-cpmin(3)+1);
    
    out3 = rot90(squeeze(sum(minvol2(:,1+pad+sp:end-pad-sp,:),2)));
    out4 = rot90(squeeze(sum(minvol2(:,:,1+pad+sp:end-pad-sp),3)));
    
    out3 = repmat(out3,thadd,1);
    out3 = reshape(out3,size(out3,1)/thadd,size(out3,2)*thadd);
    
    out4 = repmat(out4,thadd,1);
    out4 = reshape(out4,size(out4,1)/thadd,size(out4,2)*thadd);
    
    %normering med max, ok? borde normeras med antal summerade pixlar el likn?
    out3 = out3./max(max(out3));
    out4 = out4./max(max(out4));
    
    
    threshold = 0.5;
    
    
    if plot_im
      
      %plotta%-----------------------%
      figure(11)                     %
      set(gcf,'Name','Projections'); %
      hold off                       %
      subplot(1,2,1)                 %
      imagesc(out3);                 % 
      axis image;                    %
      subplot(1,2,2)                 %
      imagesc(out4);                 %
      axis image;                    %
      colormap gray                  %          
      %------------------------------%
      
      %plotta%------------------------------------%
      figure(33)                                  %
      set(gcf,'Name','Thresholded projections');  %
      hold off                                    %
      subplot(1,2,1)                              %
      imagesc((out3>threshold).*out3);            %
      subplot(1,2,2)                              %
      imagesc((out4>threshold).*out4);            %
      colormap gray                               %
      %-------------------------------------------%
    

      
      %plotta%-----------------------%
      figure(1)                      %
      set(gcf,'Name','Projections'); %
      hold off                       %
      subplot(1,2,1)                 %
      imagesc(out1);                 %  
      axis image;                    %
      subplot(1,2,2)                 %
      imagesc(out2);                 %
      axis image;                    %
      colormap gray                  %
      %------------------------------%
    
    
      %--------------------------------------------------%
      figure(4)                                          %
      set(gcf,'Name','Current slice');                   %
      subplot(1,2,1);
      hold off
      imagesc(squeeze(minvol(slicepad+1,:,:)));          %
      hold on 
      plot(round(size(minvol,2)/2),round(size(minvol,3)/2),'rs');
      axis image                                         %
      colormap gray                                      %
      
      
      subplot(1,2,2);
      hold off
      imagesc(squeeze(minvol2(slicepad+1,:,:)));         %
      hold on
      plot(round(size(minvol2,2)/2),round(size(minvol2,3)/2),'rs');
      axis image                                         %
      colormap gray                                      %
                                                         
      %--------------------------------------------------%
    
      %plotta%-----------------------------------%
      figure(3)                                  %
      set(gcf,'Name','Thresholded projections'); %
      hold off                                   %
      subplot(1,2,1)                             %
      imagesc((out1>threshold).*out1);           %
      subplot(1,2,2)                             %
      imagesc((out2>threshold).*out2);           %
      colormap gray                              %
      %------------------------------------------%
    
    end
      
    %TODO:
    %tr�skla summabilderna f�re transformering f�r att f� bort skr�p...
    %blir inte s� bra p� ideala fiberna?
    [R1,xp1] = radon((out1>threshold).*out1,angles);
    [R2,xp2] = radon((out2>threshold).*out2,angles);
    
    [R3,xp3] = radon((out3>threshold).*out3,angles);
    [R4,xp4] = radon((out4>threshold).*out4,angles);
    
    sxout1 = size(out1,2);
    sxout2 = size(out2,2);
    sxout3 = size(out3,2);
    sxout4 = size(out4,2);
    
    %correct the transform, normalize
    Rcorr1t=radon(ones(size(out1,1),size(out1,2)),angles);
    Rcorr1 = Rcorr1t;
    Rcorr1(Rcorr1<sxout1)=sxout1; %allt som �r mindre �n
    R1 = R1./Rcorr1;              %bildbredden normeras med bildbredden
     
    Rcorr2=radon(ones(size(out2,1),size(out2,2)),angles);
    Rcorr2(Rcorr2<sxout2)=sxout2;
    R2 = R2./Rcorr2;
     
    Rcorr3=radon(ones(size(out3,1),size(out3,2)),angles);
    Rcorr3(Rcorr3<sxout3)=sxout3;
    R3 = R3./Rcorr3;
     
    Rcorr4=radon(ones(size(out4,1),size(out4,2)),angles);
    Rcorr4(Rcorr4<sxout4)=sxout4;
    R4 = R4./Rcorr4;
     

    if plot_im

      %plotta%---------------------------------------%
      figure(2)                                      %
      set(gcf,'Name','Radon transform');             %

      hold off                                       %
      subplot(1,2,1)                                 %
      imagesc(angles,xp1,R1);  
      axis image
      xlabel('Thetha (\theta)');
      ylabel('Radius (r)');
      
      subplot(1,2,2)                                 %
      imagesc(angles,xp1,R2);        
      axis image
      xlabel('Thetha (\theta)');
      ylabel('Radius (r)');
      colormap jet                                   %
      %----------------------------------------------%
    
      %plotta%---------------------------------------%
      figure(22)                                     %
      set(gcf,'Name','Radon transform');             %
      
      hold off                                       %
      subplot(1,2,1)                                 %
      imagesc(angles,xp2,R3);        
      xlabel('Thetha (\theta)');
      ylabel('Radius (r)');
      axis image

      subplot(1,2,2)                                 %
      imagesc(angles,xp2,R4); 
      xlabel('Thetha (\theta)');
      ylabel('Radius (r)');
      axis image
      colormap jet                                   %
      %----------------------------------------------%
      
      
    end
    
    
    sR1 = size(R1,1);
    sR2 = size(R2,1);
    
    sR3 = size(R3,1);
    sR4 = size(R4,1);
    
    
    %TODO: s�k efter maxima som ligger n�ra d�r vi vet att 
    %de var f�rra g�ngen i f�rra slicen. S�k ocks� inte endast efter
    %ett ensamt maxima utan efter ett lite mer spritt s�dant
    %som motsvarar en tjockare linje.
    
    limit = 0.10; %gr�ns f�r hur mycket vi skall medelv�dersbilda med
    val = 0.5; %gr�ns f�r hur litet ett max f�r vara (hur m�nga
               %procent av pixlarna det kan bygga p�)
    
    %out1
    part1 = R1(1:round(sR1/2),:);
    mm1 = find_maxima(part1,val,limit,0,xp1,angles,thadd);
    
    part2 = R1(round(sR1/2)+1:end,:);
    mm2 = find_maxima(part2,val,limit,round(sR1/2),xp1,angles,thadd);

    
    %out2
    part3 = R2(1:round(sR2/2),:);
    mm3 = find_maxima(part3,val,limit,0,xp1,angles,thadd);
    
    part4 = R2(round(sR2/2)+1:end,:);
    mm4 = find_maxima(part4,val,limit,round(sR2/2),xp1,angles,thadd);
    
    
    %out3
    part5 = R3(1:round(sR3/2),:);
    mm5 = find_maxima(part5,val,limit,0,xp2,angles,thadd);
  
    part6 = R3(round(sR3/2)+1:end,:);
    mm6 = find_maxima(part6,val,limit,round(sR3/2),xp2,angles,thadd);
    
    
    %out4
    part7 = R4(1:round(sR4/2),:);
    mm7 = find_maxima(part7,val,limit,0,xp2,angles,thadd);
    
    part8 = R4(round(sR4/2)+1:end,:);
    mm8 = find_maxima(part8,val,limit,round(sR4/2),xp2,angles,thadd);

    
    
    %TESTA MAXIMANA I TRE STEG...
    
    single_maxima = [];
    
    nmax = [];
    valuemax = [];
    
    if (size(mm1,2)==1 & size(mm2,2)==1)
      single_maxima = [single_maxima 1];
      nmax = [nmax 1];
      valuemax = [valuemax sum([mm1(1,1) mm2(1,1)])]; 
      r1_est(nstep) = abs(mm1(2,1))+abs(mm2(2,1));
    else
      r1_est(nstep) = 0;
    end
    
       
    if (size(mm3,2)==1 & size(mm4,2)==1)
      single_maxima = [single_maxima 2];
      nmax = [nmax 2];
      valuemax = [valuemax sum([mm3(1,1) mm4(1,1)])]; 
      r2_est(nstep) = abs(mm3(2,1))+abs(mm4(2,1));
    else
      r2_est(nstep) = 0;
    end
    
       
    if (size(mm5,2)==1 & size(mm6,2)==1)
      single_maxima = [single_maxima 3];
      nmax = [nmax 3];
      valuemax = [valuemax sum([mm5(1,1) mm6(1,1)])]; 
      r3_est(nstep) = abs(mm5(2,1))+abs(mm6(2,1));
    else
      r3_est(nstep) = 0;
    end
    
       
    if (size(mm7,2)==1 & size(mm8,2)==1)
      single_maxima = [single_maxima 4];
      nmax = [nmax 4];
      valuemax = [valuemax sum([mm7(1,1) mm8(1,1)])]; 
      r4_est(nstep) = abs(mm7(2,1))+abs(mm8(2,1));
    else
      r4_est(nstep) = 0;
    end


    [Y,I] = sort(nmax);
    nmax = nmax(I);
    valuemax = valuemax(I);
    
    nmax
        
    
    if length(nmax) < 2
      

      disp('Special 1!...');
      pause      
      
      
      %om ena �r synlig bra och singel, estimera andra sidan utifr�n
      %f�rra storleken

      %thmax = 0.08; %radianer
      thmax = 10;
      
      if isempty(find(nmax==1))
      
        r1_est_tmp = r1_est(nstep-5:nstep-1);
        r1_est_tmp = sum(r1_est_tmp(find(r1_est_tmp)))./length(find(r1_est_tmp~=0));
        
        if (size(mm1,2)==1 & size(mm2,2)>1)
          if r1_est_tmp~=0
            for m = 1:size(mm2,2)
              diffr(m)=abs(abs(mm1(2,1))+abs(mm2(2,m))-r1_est_tmp);
              diffth(m)=abs(mm1(3,1)-mm2(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 1];
              %%l�gg till i specialvariabel h�r?
              mmx = mm2(:,m);
              mm2(:,I1(1)) = mmx;
            elseif I1(1)==I2(1)
              nmax = [nmax 1];
              %%l�gg till i specialvariabel h�r?
              mmx = mm2(:,m);
              mm2(:,I1(1)) = mmx;
            end
          end
        end
        
        
        if (size(mm2,2)==1 & size(mm1,2)>1)
          if r1_est_tmp~=0
            for m = 1:size(mm1,2)
              diffr(m)=abs(abs(mm2(2,1))+abs(mm1(2,m))-r1_est_tmp);
              diffth(m)=abs(mm2(3,1)-mm1(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 1];
              %%l�gg till i specialvariabel h�r?
              mmx = mm1(:,m);
              mm1(:,I1(1)) = mmx;
              elseif I1(1)==I2(1)
                nmax = [nmax 1];
                %%l�gg till i specialvariabel h�r?
                mmx = mm1(:,m);
                mm1(:,I1(1)) = mmx;
            end
            
          end
        end
      
      end
      
      if isempty(find(nmax==2))  
        
        r2_est_tmp = r2_est(nstep-5:nstep-1);
        r2_est_tmp = sum(r2_est_tmp(find(r2_est_tmp)))./length(find(r2_est_tmp~=0));
      
        if (size(mm3,2)==1 & size(mm4,2)>1)
          if r2_est_tmp~=0
            for m = 1:size(mm4,2)
              diffr(m)=abs(abs(mm3(2,1))+abs(mm4(2,m))-r2_est_tmp);
              diffth(m)=abs(mm3(3,1)-mm4(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
                       
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 2];
              %%l�gg till i specialvariabel h�r?
              mmx = mm4(:,m);
              mm4(:,I1(1)) = mmx;
            elseif I1(1)==I2(1)
              nmax = [nmax 2];
              %%l�gg till i specialvariabel h�r?
              mmx = mm4(:,m);
              mm4(:,I1(1)) = mmx;
            end
          end
        end
        
        if (size(mm4,2)==1 & size(mm3,2)>1)
          if r2_est_tmp~=0
            for m = 1:size(mm3,2)
              diffr(m)=abs(abs(mm4(2,1))+abs(mm3(2,m))-r2_est_tmp);
              diffth(m)=abs(mm4(3,1)-mm3(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
                                  
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 2];
              %%l�gg till i specialvariabel h�r?
              mmx = mm3(:,m);
              mm3(:,I1(1)) = mmx;
            elseif I1(1)==I2(1)
              nmax = [nmax 2];
              %%l�gg till i specialvariabel h�r?
              mmx = mm3(:,m);
              mm3(:,I1(1)) = mmx;
            end
          end
        end
        
      end
      
      
      if isempty(find(nmax==3))
      
        r3_est_tmp = r3_est(nstep-5:nstep-1);
        r3_est_tmp = sum(r3_est_tmp(find(r3_est_tmp)))./length(find(r3_est_tmp~=0));
        
        if (size(mm5,2)==1 & size(mm6,2)>1)
          if r3_est_tmp~=0
            for m = 1:size(mm6,2)
              diffr(m)=abs(abs(mm5(2,1))+abs(mm6(2,m))-r3_est_tmp);
              diffth(m)=abs(mm5(3,1)-mm6(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
                                  
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 3];
              %%l�gg till i specialvariabel h�r?
              mmx = mm6(:,m);
              mm6(:,I1(1)) = mmx;
            elseif I1(1)==I2(1)
              nmax = [nmax 3];
              %%l�gg till i specialvariabel h�r?
              mmx = mm6(:,m);
              mm6(:,I1(1)) = mmx;
            end
          end
        end
        
        if (size(mm6,2)==1 & size(mm5,2)>1)
          if r3_est_tmp~=0
            for m = 1:size(mm5,2)
              diffr(m)=abs(abs(mm6(2,1))+abs(mm5(2,m))-r3_est_tmp);
              diffth(m)=abs(mm6(3,1)-mm5(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 3];
              %%l�gg till i specialvariabel h�r?
              mmx = mm5(:,m);
              mm5(:,I1(1)) = mmx;
            elseif I1(1)==I2(1)
              nmax = [nmax 3];
              %%l�gg till i specialvariabel h�r?
              mmx = mm5(:,m);
              mm5(:,I1(1)) = mmx;
            end
          end
        end
        
      end
      
      
      if isempty(find(nmax==4))
        
        r4_est_tmp = r4_est(nstep-5:nstep-1);
        r4_est_tmp = sum(r4_est_tmp(find(r4_est_tmp)))./length(find(r4_est_tmp~=0));
        
        if (size(mm7,2)==1 & size(mm8,2)>1)
          if r4_est_tmp~=0
            for m = 1:size(mm8,2)
              diffr(m)=abs(abs(mm7(2,1))+abs(mm8(2,m))-r4_est_tmp);
              diffth(m)=abs(mm7(3,1)-mm8(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 4];
              %%l�gg till i specialvariabel h�r?
              mmx = mm8(:,m);
              mm8(:,I1(1)) = mmx;
            elseif I1(1)==I2(1)
              nmax = [nmax 4];
              %%l�gg till i specialvariabel h�r?
              mmx = mm8(:,m);
              mm8(:,I1(1)) = mmx;
            end
          end
        end
        
        if (size(mm8,2)==1 & size(mm7,2)>1)
          if r4_est_tmp~=0
            for m = 1:size(mm7,2)
              diffr(m)=abs(abs(mm8(2,1))+abs(mm7(2,m))-r4_est_tmp);
              diffth(m)=abs(mm8(3,1)-mm7(3,m));
            end
            
            [Y1,I1]=sort(diffr);
            [Y2,I2]=sort(diffth);
            
            if (diffth(I1(1))<thmax & diffth(I2(1))<thmax)
              nmax = [nmax 4];
              %%l�gg till i specialvariabel h�r?
              mmx = mm7(:,m);
              mm7(:,I1(1)) = mmx;
            elseif I1(1)==I2(1)
              nmax = [nmax 4];
              %%l�gg till i specialvariabel h�r?
              mmx = mm7(:,m);
              mm7(:,I1(1)) = mmx;
            end
          end
        end
        
      end

      nmax
      
    end
    
    

 
    if length(nmax) < 2

      disp('Special 2! Not implemented yet!');
      pause      
       
    end
    
    
    %om den ena �r synlig OK och den andra �r multipel
    %kolla p� gamla avs�ndet vilket av maxen som verkar OK
    %�ven gamla vinkeln?
    % i detta fall f�r vi nya v�rden p� allt inom maxet
    
    
    %hur rankar man maxen???
    % 1) om b�da �r enkla och syns
    % 2) om ena �r enkelt och andra g�r att hitta ett mostvarande
    % max i
    %3) om ena saknas kan man bygga det utifr�n det andra
    %skall man endast anv�nda tv� eller
    %flera korsningar i 3D och medelv�rdet mellan dem?
    
      
    %hitta p� n�got bra h�r om hur vi g�r vidare om inget �r bra
    %jobba med radier och s�dan om de finns estimerade
    
          
    if length(nmax) >= 2
    
      disp('Two projections OK. Continue tracking...');
      track = 1;         
        
      m12 = 0;
      m34 = 0;
      m56 = 0;
      m78 = 0;
      
      switch nmax(1)
       case 1
        m12 = 1;
       case 2
        m34 = 1;
       case 3
        m56 = 1;
       case 4
        m78 = 1;
      end
      
      switch nmax(2)
       case 1
        m12 = 1;
       case 2
        m34 = 1;
       case 3
        m56 = 1;
       case 4
        m78 = 1;
      end
      
        
      t = 0;
      
      if m12
        if t < 2
          t = t + 1;
          T(:,:,t) = B;
        
          rt1(t) = mm1(2,1);
          rt2(t) = mm2(2,1);
          
          tt1(t) = mm1(3,1);
          tt2(t) = mm2(3,1);
          
          zrot(t)=0;
        end
      end
      
      if m34
        if t < 2
          t = t + 1;
          T(:,:,t) = B;
          
          rt1(t) = mm3(2,1);
          rt2(t) = mm4(2,1);
          
          tt1(t) = mm3(3,1);
          tt2(t) = mm4(3,1);
          
          zrot(t) = 1;
        end
      end
      
      t
      
      if m56
        if t < 2
          t = t + 1;
          T(:,:,t) = Brot; %Brot
          
          rt1(t) = mm5(2,1);
          rt2(t) = mm6(2,1);
          
          tt1(t) = mm5(3,1);
          tt2(t) = mm6(3,1);
          
          zrot(t) = 0;
        end
      end
      
      if m78
        if t < 2
          t = t + 1;
          T(:,:,t) = Brot; %Brot
          
          rt1(t) = mm7(2,1);
          rt2(t) = mm8(2,1);
          
          tt1(t) = mm7(3,1);
          tt2(t) = mm8(3,1);
          
          zrot(t) = 1;
        end
      end
      

      
      b(1) = mean([rt1(1) rt2(1)]);
      b(2) = mean([rt1(2) rt2(2)]);

      
      % O B S! ! ! ! ! !
      %TA H�NSYN TILL DEN SNEDA PROJEKTIONEN H�R OCKS�
      %rb_new = abs(yr1)+abs(yr2)+2*pad;
      %rh_new = abs(yr3)+abs(yr4)+2*pad;
      rb_new = abs(rt1(1))+abs(rt2(1))+2*pad;
      rh_new = abs(rt1(2))+abs(rt2(2))+2*pad;
      
      %vinklarna mot -y' (i out-bilden)
      thm(1) = (tt1(1)+tt2(1))/2; %vinkel i radianer, noll ned�t?
      thm(2) = (tt1(2)+tt2(2))/2; %vinkel i radianer, noll ned�t?
      
      %thm
      
      %t12m �r projektionen p� z'V-planet
      % rotera kring x'
      %B
      %t34m �r projektionen p� x'V-planet
      %rotera kring z'
      
      for n=1:2
        
        if zrot(n)==0  %rotate around x
          
          disp(['Rotate ' num2str(n) ' around x...']);
        
          fnz = -[1;0]; %ned�t �r noll radianer/grader, rotera denna vektor
          fnz = [cos(thm(n)) sin(thm(n));
              -sin(thm(n)) cos(thm(n))]*fnz;
         
          zrotated = T(:,:,n)*[-fnz(2); 0 ;-fnz(1)];
          
          nhat(:,n) = cross(T(:,2,n),zrotated); %xprim x zrotated
          
          %vol(V,x,z)
          p1(:,n) = T(:,:,n)*[0; 0; b(n)];
          p2(:,n) = T(:,:,n)*[0; 1; b(n)];
          
          
        else %rotate around z
          
          disp(['Rotate ' num2str(n) ' around z...']);
          
          fnx = -[1;0]; %ned�t, rotera sedan mot klockan thm-grader
          fnx = [cos(thm(n)) sin(thm(n));
                -sin(thm(n)) cos(thm(n))]*fnx;
          
          xrotated = T(:,:,n)*[-fnx(2); 0 ;-fnx(1)];
          
          nhat(:,n) = cross(T(:,3,n),xrotated); %zprim x xrotated
          
          %vol(V,x,z)
          p1(:,n) = T(:,:,n)*[0; b(n);0];
          p2(:,n) = T(:,:,n)*[0; b(n);1];
          
        end
      end
      
      nhat(:,1) = nhat(:,1)./norm(nhat(:,1),2);
      nhat(:,2) = nhat(:,2)./norm(nhat(:,2),2);
      
      Vnew = cross(nhat(:,1),nhat(:,2));
      Vnew = Vnew./norm(Vnew,2); %2-normen;

      %kolla s� den g�r �t samma h�ll som V, ok??
      if(Vnew'*V)<0.5
        Vnew = -Vnew;
      end
            
      est = LineLineIntersect(p1(:,1),p2(:,1),p1(:,2),p2(:,2))';
      
      mv_est = mv + est;
      
      mv_new = mv_est + tstep*Vnew;
      
      if step_through
        %pausa f�r att se resultat stegvis
        pause
      end
      
      V = Vnew;
      mv = mv_new;
      rb = rb_new;
      rh = rh_new;
      
      mv_tot = [mv_tot, mv];
      V_tot = [V_tot, V]; 
      rb_tot = [rb_tot rb];
      rh_tot = [rh_tot rh];

    else
      
      disp('Stop tracking...');
      track = 0;
      
    end

    
  end
  
  %spara koordinaterna f�r hela fibern
  
end

