% Find all bonds and analyse their strenght using bondStrenght.m

nfibres = numel(fibres);
%nfibres = 2; % FOR DEBUG--REMOVE

distanceThreshold = 25;

verbose = 0;

for f1=1:nfibres % first fibre
       
    if verbose
        fprintf('Fibre %d selected\n', f1);    
    end
    
    f1x = fibres{f1}.xx;
    f1y = fibres{f1}.yy;
    f1z = fibres{f1}.zz;
        
    for f2=(f1+1):nfibres % second fibre           
        if verbose
            fprintf(' Other fibre: %d\n', f2);        
        end
        f2x = fibres{f2}.xx;
        f2y = fibres{f2}.yy;
        f2z = fibres{f2}.zz;
        
        distances1=nan(size(f1x));
        distances2=nan(size(f2x));
            
       contact = 0;
       for s1=1:numel(f1x) % All positions along f1                      
           mind = 10^12;
           for s2 = 1:numel(f2x) % All positions along f2               
                d = ((f1x(s1)-f2x(s2))^2+(f1y(s1)-f2y(s2))^2+(f1z(s1)-f2z(s2))^2).^(1/2);
                distances2(s2)=min(distances2(s2),d);                
                if d<mind
                    mind = min(d,mind);
                    ms2 = s2;
                end                
           end
           distances1(s1)=mind;
           
           
                if contact
                    if mind <= distanceThreshold
                        % Nothing, still contact
                    else  % If contact ended                        
                        contact = 0;
                        contactEnd1 = s1;
                        contactEnd2 = ms2;
                        
                            fprintf('  fibre %d@, [%d -- %d], fibre %d@, [%d -- %d]', ...
                            f1,contactStart1, contactEnd1, ...
                            f2, contactStart2, contactEnd2);                           
                        
                        % Use a little more of the curves if possible                                                                        
                        
                        % Indexing should be from low to high
                        if contactStart2 > contactEnd2
                            t = contactStart2;
                            contactStart2 = contactEnd2;
                            contactEnd2 = t;
                        end        
                        
                        extra = 20;
                        contactStart1=max(contactStart1-extra, 1);
                        contactStart2=max(contactStart2-extra, 1);
                        contactEnd1=min(contactEnd1+extra, numel(f1x));
                        contactEnd2=min(contactEnd2+extra, numel(f2x));
                        tic
                        bond = bondStrength(   [f1y(contactStart1:contactEnd1)', ...
                                                f1x(contactStart1:contactEnd1)', ...
                                                f1z(contactStart1:contactEnd1)'], ...
                                                distances1(contactStart1:contactEnd1), ...
                                                [f2y(contactStart2:contactEnd2)', ...
                                                f2x(contactStart2:contactEnd2)', ...
                                                f2z(contactStart2:contactEnd2)'], ...
                                                distances2(contactStart2:contactEnd2), ...
                                                V);
                           toc
                           
                        fprintf(', strength: %d\n', bond);
                    end
                else
                    if mind > distanceThreshold
                        % Nothing, still no contact
                    else % Contact
                        contact = 1;
                        contactStart1 = s1;
                        contactStart2 = ms2;
                    end
                end                                  
       end
    
           
    %% Intepolate the line between the points
    
    %ix = linspace(x, bx, round(mind));
    %iy = linspace(y, by, round(mind));
    %iz = linspace(z, bz, round(mind));
    %line = trilinear8(V, ix, iz, iy);           
    % Returns -1 if it can't figure out the distances
    %fibreDistances(kk)=distanceFromLine(line)*mind/round(mind);
    
    end
end
