
% Select a fibre randomly, the probability depends on the length of it
% throught the volume

%% Get the length of
%L = zeros(numel(fibres), 1);
%for kk=1:numel(fibres)   
%    x = fibres{kk}.xx;
%    y = fibres{kk}.yy;
%    z = fibres{kk}.zz;
%    if numel(x)>0
%        L(kk)=curveLength(x,y,z);
%    else
%        L(kk)=0;
%    end
%end

lls = cumsum(L);

lls = lls/lls(end);

figure(3)
hold on

dans = inputdlg('How many measurements?', 'distanceDistribution', 1, {'250'});
ndistances = str2num(dans{1});

centerlineDistances=zeros(ndistances,1);
fibreDistances=zeros(ndistances,1);

for kk=1:ndistances
   
    f = 0;
    while f==0
    f = rand(1);
    f = find(lls>=f);
    f = f(1);    
    if numel(fibres{f})==0
        f = 0;
    else
        if numel(fibres{f}.xx) == 0
            f = 0;
        end
    end
    end
    fprintf('Fibre %d selected\n', f);
    
    x = fibres{f}.xx;
    y = fibres{f}.yy;
    z = fibres{f}.zz;
    
    % Select a postion along the fibre
    p = ceil(numel(x)*rand(1)+eps);
    
    x=x(p); y = y(p); z = z(p);
    mind = 10^12;
    % Compare to all other fibres
    for ll=[1:f-1, f+1:numel(fibres)]        
        if numel(fibres{ll}) >0
            if numel(fibres{ll}.xx)>0
        ox = fibres{ll}.xx;
        oy = fibres{ll}.yy;
        oz = fibres{ll}.zz;
       for mm=1:numel(ox) % And all positions in them
           d = ((x-ox(mm))^2+(y-oy(mm))^2+(z-oz(mm))^2).^(1/2);
           if d < mind % If the minimal distance, store postion and fibre nr               
               bx = ox(mm); by = oy(mm); bz = oz(mm);
               bf = ll;
               mind = d;
           end
       end
            end
        end
    end

    centerlineDistances(kk)=mind;
    
    %% Intepolate the line between the points
    
    ix = linspace(x, bx, round(mind));
    iy = linspace(y, by, round(mind));
    iz = linspace(z, bz, round(mind));
    line = trilinear8(V, ix, iz, iy);       
    
    % Returns -1 if it can't figure out the distances
    fibreDistances(kk)=distanceFromLine(line)*mind/round(mind);

    figure(3)
    plot3([x,bx], [y,by], [z,bz],'w')
    %drawnow    
end

figure, plot(centerlineDistances, fibreDistances, '.')
xlabel('centerlineDistance [pu]')
ylabel('fibreDistance [pu]')
axis([0, max(centerlineDistances), 0, max(centerlineDistances)]);


fibreDistances = fibreDistances(fibreDistances>0);

%% Display the findings
nbins = 20;
w = max(centerlineDistances)/nbins;
bins = 0.5*w:w:(max(centerlineDistances)+0.5*w);
figure,
subplot(1,2,1)
hist(centerlineDistances, bins)
xlabel('distance (centerline to centerline)')
ylabel(sprintf('number (total: %d)', ndistances))
subplot(1,2,2)
hist(fibreDistances, bins)
xlabel('distance (fibre to fibre)')
ylabel(sprintf('number (total: %d)', numel(fibreDistances)))
set(gcf,'PaperPositionMode','auto')