function d = distanceFromLine(line)
verbose = 0;

th = 110;  % Threshold

if verbose
    figure(8)
    clf
    plot(line/max(line))
    hold on
end

line(line<th)=0;
line(line>0)=1;
if verbose
    plot(line, 'r')
    axis([0, numel(line), -0.2, 1.2])
end

fibre = find(line==1);
if numel(fibre)==0
    d = -1;    
else    
    first_fibre = fibre(1);
    last_fibre = fibre(end);
    
    line = line(first_fibre:last_fibre);
    air = find(line==0);
    if numel(air)==0
        d = 0;
    else
        first_air = air(1);
        last_air = air(end);
        d = last_air-first_air+0.5;
    end        
end

if verbose
    title(d);
    if(d>0)
        from = first_fibre+first_air-1;
        to = first_fibre+last_air-1;
       plot([from,to  ], [0.5,0.5], 'g', 'LineWidth', 4);
    end
    pause
end

end