function drawbb(mx, my, mz, faces)
% Draw a box defined by the corners 
% [0,0,0] [mx,my,mz]
% upper right corner defines the box

hold on

if(~exist('faces', 'var'))
    faces = 1;
end

s.fa=0.2; % Face alpha. 0=transparent, 1=no transparency
s.fc=[0.5,0.6,0.5]; % Face color
border=50; % Border around the sample


% TB
[X,Y]=meshgrid(linspace(0,mx, 5), linspace(0,my,5));
Z=0*X; drawface(X,Y,Z,s);
Z=Z+mz; drawface(X,Y,Z,s);
% RL
[X,Z]=meshgrid(linspace(0,mx, 5), linspace(0,mz,5));
Y=0*Z; drawface(X,Y,Z,s);
Y=Y+my; drawface(X,Y,Z,s);
% FB
[Y,Z]=meshgrid(linspace(0,my, 5), linspace(0,mz,5));
X=0*Z; drawface(X,Y,Z,s);
X=X+mx; drawface(X,Y,Z,s);

axis([-border,mx+border, -border,my+border, -border,mz+border]);
end

function drawface(X,Y,Z, s)
    surf(X,Y,Z, 'FaceColor', s.fc, 'EdgeAlpha', 0, 'FaceAlpha', s.fa);
end