function drawbg(mx, my, mz, color)
% Draw a box defined by the corners 
% [0,0,0] [mx,my,mz]
% upper right corner defines the box

s.fa=0.2; % Face alpha. 0=transparent, 1=no transparency
s.fc=[0.5,0.6,0.5]; % Face color
border=50; % Border around the sample
s.lw = 2; % Line width
if(~exist('color', 'var'))
    s.color = 'black';
else 
    s.color = color;
end

hold on
plot3([0,mx], [0,0], [0,0], 'LineWidth', s.lw, 'Color', s.color);
plot3([0,0], [0,my], [0,0], 'LineWidth', s.lw, 'Color', s.color);
plot3([0,0], [0,0], [0,mz], 'LineWidth', s.lw, 'Color', s.color);

plot3([mx,0], [my,my], [mz,mz], 'LineWidth', s.lw, 'Color', s.color);
plot3([mx,mx], [my,0], [mz,mz], 'LineWidth', s.lw, 'Color', s.color);
plot3([mx,mx], [my,my], [mz,0], 'LineWidth', s.lw, 'Color', s.color);

plot3([mx,mx], [my,0], [0,0], 'LineWidth', s.lw, 'Color', s.color);
plot3([mx,mx], [0,0], [mz,0], 'LineWidth', s.lw, 'Color', s.color);

plot3([mx,0], [my,my], [0,0], 'LineWidth', s.lw, 'Color', s.color);
plot3([0,0], [my,my], [mz,0], 'LineWidth', s.lw, 'Color', s.color);

plot3([0,0], [0,0], [mz,mz], 'LineWidth', s.lw, 'Color', s.color);
plot3([mx,0], [0,0], [mz,mz], 'LineWidth', s.lw, 'Color', s.color);
plot3([0,0], [my,0], [mz,mz], 'LineWidth', s.lw, 'Color', s.color);

axis([-border,mx+border, -border,my+border, -border,mz+border]);
end
