clear all
t = (-60:60)';
theta1 = 0;
theta2 = pi/8;

z1 = 20;
z2 = 45;

c1(:,1) = 50+t*cos(theta1);
c1(:,2) = 50+t*sin(theta1);
c1(:,3) = 0*t+z1;

c2(:,1) = 50+t*cos(theta2);
c2(:,2) = 50+t*sin(theta2);
c2(:,3) = 0*t+z2;

% Find out minimal box that contains the lines
minx=min([c1(:,1); c2(:,1)]);
maxx=max([c1(:,1); c2(:,1)]);

miny=min([c1(:,2); c2(:,2)]);
maxy=max([c1(:,2); c2(:,2)]);

minz=min([c1(:,3); c2(:,3)]);
maxz=max([c1(:,3); c2(:,3)]);

minx=round(minx); maxx=round(maxx);
miny=round(miny); maxy=round(maxy);
minz=round(minz); maxz=round(maxz);


ROI = zeros(maxx-minx+1, maxy-miny+1, maxz-minz+1);

c1r = [c1(:,1)-minx+1, c1(:,2)-miny+1, c1(:,3)-minz+1];
c2r = [c2(:,1)-minx+1, c2(:,2)-miny+1, c2(:,3)-minz+1];

% Draw the fibres
for kk=1:4:size(c1,1)
    progressbar(kk,size(c1,1));
    radius = 15;
    ROI = addball3(ROI, c1r(kk,1), c1r(kk,2), c1r(kk,3), radius, 1); 
end

for kk=1:4:size(c2,1)
    progressbar(kk,size(c2,1));
    radius = 15;
    ROI = addball3(ROI, c2r(kk,1), c2r(kk,2), c2r(kk,3), radius, 1); 
end

volumeSlide(ROI)
%s = bondStrength(ROI,

break

%% old:
%%
%%
%%

clear all
t = (-40:40)';
theta1 = 0;
theta2 = pi/8;

z1 = 20;
z2 = 45;

c1(:,1) = 50+t*cos(theta1);
c1(:,2) = 50+t*sin(theta1);
c1(:,3) = 0*t+z1;

c2(:,1) = 50+t*cos(theta2);
c2(:,2) = 50+t*sin(theta2);
c2(:,3) = 0*t+z2;

% Find out minimal box that contains the lines
minx=min([c1(:,1); c2(:,1)]);
maxx=max([c1(:,1); c2(:,1)]);

miny=min([c1(:,2); c2(:,2)]);
maxy=max([c1(:,2); c2(:,2)]);

minz=min([c1(:,3); c2(:,3)]);
maxz=max([c1(:,3); c2(:,3)]);

minx=round(minx); maxx=round(maxx);
miny=round(miny); maxy=round(maxy);
minz=round(minz); maxz=round(maxz);

border = 10;
ROI = zeros(maxx-minx+2*border, maxy-miny+2*border, maxz-minz+2*border);

% Draw the fibres
for kk=1:4:size(c1,1)
    progressbar(kk,size(c1,1));
    radius = 15;
    ROI = addball3(ROI, c1(kk,1)-minx+border, c1(kk,2)-miny+border, c1(kk,3)-minz+border, radius, 1); 
end

for kk=1:4:size(c2,1)
    progressbar(kk,size(c2,1));
    radius = 15;
   ROI = addball3(ROI, c2(kk,1)-minx+border, c2(kk,2)-miny+border, c2(kk,3)-minz+border, radius, 1); 
end

% Draw the seeds
for kk=1:4:size(c1,1)
    progressbar(kk,size(c1,1));
    radius = 10;
   ROI = addball3(ROI, c1(kk,1)-minx+border, c1(kk,2)-miny+border, c1(kk,3)-minz+border, radius, 2); 
end

for kk=1:4:size(c2,1)
    progressbar(kk,size(c2,1));
    radius = 10;
   ROI = addball3(ROI, c2(kk,1)-minx+border, c2(kk,2)-miny+border, c2(kk,3)-minz+border, radius, 3); 
end




figure,
plot3(c1(:,2)-miny+border, c1(:,1)-minx+border, c1(:,3)-minz+border);
hold on
plot3(c2(:,2)-miny+border, c2(:,1)-minx+border, c2(:,3)-minz+border, 'r');
[f,v]=isosurface(ROI,0.5);
[f2,v2]=isocaps(ROI,0.5);
patch('Faces', f, 'Vertices', v, 'Facecolor', [.5,.5,.5], 'EdgeAlpha', 0, 'FaceAlpha', 1);
patch('Faces', f2, 'Vertices', v2, 'Facecolor', [.5,.5,.5], 'EdgeAlpha', 0, 'FaceAlpha', 1);
%isosurface(ROI,1.5)
view(3)
camlight
axis equal

[f,v]=isosurface(ROI==2,0.5);
%patch('Faces', f, 'Vertices', v, 'Facecolor', [.5,.8,.5], 'EdgeAlpha', 0);

[f,v]=isosurface(ROI==3,0.5);
%patch('Faces', f, 'Vertices', v, 'Facecolor', [.8,.5,.5], 'EdgeAlpha', 0);

%isosurface(ROI,1.5)
view(3)
camlight
axis equal

% This results in flow = 1
%ROI(:,:,23)=0;
%ROI(50,50,23)=1;
%pause

tic
[S, flow] = fiberCut3(uint8(ROI));
toc

title(['angle=' num2str(theta2-theta1) ' area =' num2str(flow)])
% print -dpng link4.png


% Visualise the cut
figure
[f,v]=isosurface(pad3dmatrix(ROI,1),0.5);
patch('Faces', f, 'Vertices', v, 'Facecolor', [.5,.5,.5], 'EdgeAlpha', 0, 'FaceAlpha', .4);
[f,v]=isosurface(pad3dmatrix(S,1),2.5);
patch('Faces', f, 'Vertices', v, 'Facecolor', [0,0,1], 'EdgeAlpha', 0, 'FaceAlpha', 1);
view(3)
camlight
axis equal


%end

break
figure,
volumeSlide(S)

pause
% Test fiberCut2:
mex -largeArrayDims fiberCut3.cpp
% 1. A link in the z-direction
T = zeros(50,50,50);
T(20,20,:)=1;
T(:,:,1)=2;
T(:,:,end)=3;
tic
[S, flow] = fiberCut3(uint8(T));
toc
flow
% 2. A link in the y-direction
T = zeros(50,50,50);
T(20,:,20)=1;
T(:,1,:)=2;
T(:,end,:)=3;
tic
[S, flow] = fiberCut3(uint8(T));
toc
flow
% 3. A link in the x-direction
T = zeros(50,50,50);
T(:,20,20)=1;
T(1,:,:)=2;
T(end,:,:)=3;
tic
[S, flow] = fiberCut3(uint8(T));
toc
flow

% Flow from one source should be 6
T = ones(21,21,21);
T(11,11,11)=2;
%T(15,11,15)=2;
T(:,:,1)=3;
[S, flow] = fiberCut3(uint8(T));
flow
