function [S,area]=fiberCut3c(I)

%mex  -v mflow3.cpp flow3.cpp CXXFLAGS="\$CXXFLAGS -fopenmp" LDFLAGS="\$LDFLAGS -fopenmp" -largeArrayDims


I(:,:,1)=0; I(:,:,end)=0;
I(:,1,:)=0; I(:,end,:)=0;
I(1,:,:)=0; I(end,:,:)=0;

pressure = .5*ones(size(I));
pressure(I==0)=0;
pressure(I==2)=1;
pressure(I==3)=0;

[J, iter] = mflow3(I, pressure, 5000); %% 

A = I>0 & J<0.5;
A = gsmooth(A,.7);
B = I>0 & J>0.5;
B = gsmooth(B,.7);
[fa, va]=isosurface(pad3dmatrix(A,1));
[fb, vb]=isosurface(pad3dmatrix(B,1));

figure
patch('Faces', fa, 'Vertices', va, 'FaceColor', [.5,.5,.5], 'FaceAlpha', .4, 'EdgeAlpha', 0)
%vb(:,3)=vb(:,3)-7;
hold on
patch('Faces', fb, 'Vertices', vb, 'FaceColor', [1,.5,.5], 'FaceAlpha', 1, 'EdgeAlpha', 0)
axis vis3d
view(3)
axis equal
camlight
lighting phong
material dull

axis off

% get the area of the cut
[f,v]=isosurface(pressure,0.5);
% values of I at the vertices
values = interpn(double(I>0), v(:,2), v(:,1), v(:,3)); 
area = 0;
for kk=1:size(f,1) % For each triangle
    ta = triangleArea(f,v,kk); % triangle area
    if values(f(kk,1))==1
        area=area+1/3*ta;
    end
    if values(f(kk,2))==1
        area=area+1/3*ta;
    end
    if values(f(kk,3))==1
        area=area+1/3*ta;
    end
end

S = J;
S(J>=.5)=2;
S(J<.5)=3;
S(I==0)=0;

end