%{ 
    Generates all statistics from already demarcated fibres.
%}



disp('statistics will be written to fibreStats.txt');
f = fopen('fibreStats.txt', 'w');

s = sprintf('Total %d fibres\n', numel(fibres));
fprintf(s);
fprintf(f,s);

s = '# \t Length (mm), \t Radius (um), \t Thickness (um), NCP \t FFL um \n';
fprintf(s);
fprintf(f,s);

ltot = 0;
for kk=1:numel(fibres)
    if numel(fibres{kk})>0 % 0 if deleted
        x = fibres{kk}.xx;
        y = fibres{kk}.yy;
        z = fibres{kk}.zz;
    if numel(x)>0
        try 
            m = fibres{kk}.m;
        catch e
            % No pre-calculated measurements, doing new
            m = contactAnalysis(V, fibres, kk);
            m.L=curveLength(x,y,z);
            fibres{kk}.m = m;
        end        
        ltot = ltot+m.L;
        if numel(m.freeLength)>0
        s = sprintf('% 4d       % 3.2f           % 3.2f           % 3.2f       % 4d     ', kk, ...
                                                m.L/1000*0.5552*2, ...
                                                m.radius*0.5552*2, ...
                                                m.thickness*0.5552*2, ...                                                
                                                m.nContactPoints);                                            
        sffl = sprintf('% 2.3f', m.freeLength*m.L/500*2*0.5552);                                     
        s = sprintf('%s %s\n', s, sffl);
        else
            s = sprintf('% 4d       % 3.2f           \n', kk, m.L/1000*0.5552*2);                                            
        end
        
        fprintf('%s', s);        
        fprintf(f, '%s', s);
    end    
    end
end

s = sprintf('\n Total length: %.2f pixel units\n', ltot);
fprintf(s);
fprintf(f,s);

fclose(f);

fprintf('Saving all measurements... ')
save fibres.mat fibres nfibres
fprintf('ok\n');

disp('to clear all statistics, type clearStatistics');
