%% Use the frenet frame to show the fibre cross sections along the fibre

fibre = 5;

xx = fibres{fibre}.xx;
yy = fibres{fibre}.yy;
zz = fibres{fibre}.zz;


[T,N,B]=frenet(xx,yy,zz);

if 0
figure,
plot3(xx,yy,zz, 'b')
hold on
for kk=1:numel(xx)
    plot3([xx(kk), xx(kk)+n(kk,1)], [yy(kk), yy(kk)+n(kk,2)],[zz(kk), zz(kk)+n(kk,3)], 'k');
    plot3([xx(kk), xx(kk)+b(kk,1)], [yy(kk), yy(kk)+b(kk,2)],[zz(kk), zz(kk)+b(kk,3)], 'r');
end
axis equal
end


r = 20;

recordFibre = 1;
if recordFibre
    writerObj = VideoWriter('fibre5.avi')
    writerObj.FrameRate = 20;
    open(writerObj);
end

for kk=1:numel(xx)
    
    t = T(kk,:);
    n = N(kk,:);
    b = B(kk,:);
    
    [u,v]=meshgrid(-r:r,-r:r);
    
    PX = xx(kk)+u*n(1)+v*b(1); 
    PY = yy(kk)+u*n(2)+v*b(2);
    PZ = zz(kk)+u*n(3)+v*b(3);
    
    Skk= trilinear8(V, PY, PZ, PX );
    Skk=double(Skk);
    figure(7)
    imagesc(Skk)
    axis image
    colormap gray
    set(gca, 'clim', [85,120])
    if recordFibre
        writeVideo(writerObj,getframe);
    end
end

close(writerObj);