function V=gsmooth(V, sigma, radius)
% Smooth a 3D volume by convolving with a gaussian (separated)
% with sigma and a specific radius (optional)
%
% Uses ridiculous amounts of memory... bug?

%iptsetpref('UseIPPL', true)

if sigma<=0.2
    disp('gsmooth: Low sigma, Not doing anything')
else
    
if ~exist('radius','var')
    radius=round(4*sigma+2);
    if (mod(radius,2)==0)
        radius=radius+1;
    end
    %fprintf('Radius = %d, ', radius);
end

%convf=@imfilter; % Handles uint8 and uint16 as well :) Alternative convn
convf=@convn;

%assert( numel(size(V))==3) % Only for 3D volumes!
if(numel(size(V))==3)    
    d=2*radius+1;
    %k=fspecial('gaussian', [d, 1], sigma);
    k=ggaussian(d, sigma);
    k1=reshape(k, [d,1,1]);
    k2=reshape(k, [1, d,1]);
    k3=reshape(k, [1,1,d]);        
    %fprintf('1... ');        
    
    V=convf(V, k1, 'same');    
%    figure, imshow2(V(:,:,1));
    %fprintf('2... ');
    V=convf(V, k2, 'same');
 %   figure, imshow2(V(:,:,1));
    %fprintf('3... ');
    V=convf(V, k3, 'same');
  %  figure, imshow2(V(:,:,1));
    %fprintf('\n');        
end

if(numel(size(V))==2)        
    d=2*radius+1;
    k=fspecial('gaussian', [d, 1], sigma);    
    k1=reshape(k, [d,1]);
    k2=reshape(k, [1, d]);    
    %fprintf('1... ');
    V=imfilter(V, k1, 'same');
    %fprintf('2... ');
    V=imfilter(V, k2, 'same');
    %fprintf('3... ');
    %fprintf('\n');
end


end
end

function test

    I=ones(100,100);
    figure    
for ss=1:2:40
    tic, s=gsmooth(I, ss);
    plot(ss, toc, 'x', 'MarkerSize', 15)        
    hold on
    tic
    s=conv2(I, fspecial('gaussian', (ceil(ss)*4+1)*[1,1], ss), 'same');
    plot(ss, toc, 'o', 'MarkerSize', 15)        
end

end