%
% Usage: see external documentation at
%        http://www.cb.uu.se/~erikw/FNXCT/
%
% and README.txt
%

addpath('tubeplot/')
addpath('trilinear/')
addpath('axelssonTracking/')
addpath('fiberBond/')

% Load a volume
if ~exist('V', 'var')
    clear all
    shownslices = 10;
    [fileName folderName]=uigetfile('*.mat');
    volumeFile = [folderName fileName];
    fprintf('loading data...');
    load(volumeFile);
    fprintf('ok.\n')
end

% Load annotations if available 
annotationFile = [volumeFile(1:end-4) '_data.mat'];
try
    load(annotationFile);
catch
   disp('No fibre data stored, starting from scratch'); 
end
if ~exist('fibres', 'var')
    nfibres = 0;
    fibres = [];
    last = 26; % Which slice to show first
end

s.projtype = 1; % Sum
oldpos = 0; % Used for showcross.m

% Start the graphical interface which will display sumv
% and allow interaction/fibre marking/generation of statistics
fibgui

%% Short reference of functions called by fibgui
% for advanced use, call the m-files maually
%{
showxy  % Fig 5
selectxy % fig 5
showz   % fig 6
selectz  % fig 6
showall3d % 'show3d'
fibreStatistics % All statistics is generated from this script
contactAnalysis % Algorithm I - free or in contact, cc geometry
distanceDistribution % 'd distribution'
bondAnalysis % Analysis all bonds using bondStrenght
removefibre % Remove the last marked fibre from the volume
savexyz
%}