function area = pcArea(I, mask, maxval)
% Partial coverage are of object defined by a mask.
% partial coverage is only considered for the edge, not the inside of the
% object.
%
% example:
% t = zeros(20,20); t(10:17,5:12)=255; t(10,5:12)=140;
% pcArea(t, t>0, 255)
% t(12,7:10)=200;
% pcArea(t, t>0, 255); % same result

emask = imerode(mask, [0,1,0;1,1,1;0,1,0]);
edge = double((mask==1) & (emask==0));
area = sum(edge(:).*I(:)/255+emask(:));

