
S= zeros(size(V,1), numel(xx));
whos
one = ones(size(V,1),1);
for kk=1:numel(xx)
    S(:,kk)=trilinear8(V, one*yy(kk), 1:size(V,1), one*xx(kk));
end

S=double(S);
% 85
% 132
Smin=50;
Smax = 200;

S = S-Smin;
S=S/(Smax-Smin);
S(S<0)=0; S(S>1)=1;
 
 % Stretch the contrast a little
S=S*1.2;
S=S-0.1;
S(S<0)=0;
S(S>1)=1;
whos
clear HSV
HSV(:,:,1)=.16*ones(size(S)); % yellow
HSV(:,:,2)=0*S;
HSV(first:last,:,2)=1;
HSV(:,:,3)=S;

figure(2)
% subplot('Position',[left bottom width height]);
figSelectz = subplot('position', [0,0.2,1,0.8]);
imshow(hsv2rgb(HSV))
colormap('gray')
axis('image')
hold on
plot([0,size(HSV,2)], [first,first],'k')
plot([0,size(HSV,2)], [last,last], 'k')




%% Orthogonal views
positions = round(linspace(10, numel(xx)-10, 5));
for ll=1:5
    subplot(figSelectz)
	pos = positions(ll);
    plot([pos, pos], [first, last], 'r')

    subplot('position', [(ll-1)*.2,0,.2,0.2])    
    cla
    cplot(ll)=gca;
    y = xx(pos); x=yy(pos);
    ny = -(xx(pos+10)-xx(pos)); nx = yy(pos+10)-yy(pos);
    
    nn = sqrt(ny^2+nx^2); ny = ny/nn; nx = nx/nn;

    OS = zeros(last-first+1, 61);
    r = linspace(-30,30,61);
    one = ones(size(OS,1),1);
    for kk=1:numel(r)
        OS(:,kk)=trilinear8(V, one*(x+ny*r(kk)), first:last, one*(y+nx*r(kk)));
    end
    imagesc(OS)
    hold on
    axis image
    axis equal
    axis off
    colormap gray
    diff = Smax-Smin;
    set(gca, 'Clim', [Smin, Smax])
    height = size(OS,1);
    width = size(OS,2);
    plot([.5,.5]*width, height*[.2, .8], 'r')    
    plot([0.2,0.8]*width, height*[0.5, 0.5], 'r')    
end

figure(2)
