%% Create crossplot in fig5 for display of orthogonal cross sections
% is updated from the gui by calling showcross

try
    delete(slideMarker)
    clear(slideMaker)
end

f = figure(5);
clf
set(f, 'menubar', 'none')
set(f, 'name', 'cross view')
set(f, 'numbertitle', 'off')
subplot('position', [0,0,1,1])
crossplot = imagesc(zeros(size(V,1), 61));
axis image
axis off
colormap gray
hold on
set(gca, 'CLim', [50,180])
lxy = plot([31,31], [1, size(V,1)], 'r', 'LineWidth', 2);
set(lxy, 'HitTest', 'off');
lz = plot([0,61], [1, 1]*(last-first)/2, 'r', 'LineWidth', 2);
set(lz, 'HitTest', 'off');
S= zeros(size(V,1), numel(xx));

one = ones(size(V,1),1);
for kk=1:numel(xx)
    S(:,kk)=trilinear8(V, one*yy(kk), 1:size(V,1), one*xx(kk));
end

%% Create the cross section along the fibre
S=double(S);
% 85
% 132
Smin=50;
Smax = 200;

S = S-Smin;
S=S/(Smax-Smin);
S(S<0)=0; S(S>1)=1;
 
 % Stretch the contrast a little
S=S*1.2;
S=S-0.1;
S(S<0)=0;
S(S>1)=1;

clear HSV
HSV(:,:,1)=.16*ones(size(S)); % yellow
HSV(:,:,2)=0*S;
HSV(first:last,:,2)=1;
HSV(:,:,3)=S;

f= figure(2);
set(f, 'menubar', 'none')
set(f, 'name', 'tz view')
set(f, 'numbertitle', 'off')

% subplot('Position',[left bottom width height]);
figSelectz = subplot('position', [0,0.0,1,1]);

showz_inter(hsv2rgb(HSV), first, last);
