function [x2] = unitspeed1(x, varargin)
% Re-interpolate the signal (x,y) so that the spacing is equal
% unitspeed(x,y,N) interpolate using N points

if ~exist('x','var')
    demo
    return
end

if numel(varargin)==1
    nOutPoints = varargin{1}
else
    nOutPoints = numel(x);
end

x2 = linspace(x(1), x(end), nOutPoints);

end

function demo
x= rand(5,1);
x = sort(x);

figure
subplot(1,2,1)
xx = spline(1:numel(x),x, linspace(1,numel(x),50));
plot(xx, zeros(numel(xx)), 'k');
hold on
plot(xx, zeros(numel(xx)), 'rx');
%plot(x,'o', 'MarkerSize', 15)
title('Input signal')
subplot(1,2,2)
[x2]=unitspeed1(xx, 50);
plot(x2, zeros(numel(x2)), 'k')
hold on
plot(x2,zeros(numel(x2)),'rx')
title('Unit speed output')


end

