function [] = volumeSlide(V)

nslices = size(V,3);
slice = round(nslices/2);
newslice = 0; xstart = 0;
mode = 1; % Scroll z

fig = figure(1)
clf
plo = subplot('Position', [0,0,1,1]);
img = imagesc(V(:,:,slice));
ah = gca;
hold on
Line = plot(0,0, 'r', 'LineWidth', 3);

P = zeros(2,3);


colormap gray
axis image
axis off



set(fig, 'name', sprintf('Slice: %d', slice));
set(fig, 'WindowButtonDownFcn', @startMove);
set(fig, 'WindowButtonUpFcn', @endMove);
set(fig, 'WindowKeyPressFcn', @modeSwitch)

    function startMove(varargin)
        if mode == 1
            set(fig, 'WindowButtonMotionFcn', @move);
            Q= get(fig, 'CurrentPoint');
            xstart = Q(2);
            newslice = slice;
        end
        
        if mode == 2
            % Return the clicked point to workspace
            PT= get(ah, 'CurrentPoint');
            selection  = get(gcf,'SelectionType');
            if strcmp(selection, 'normal')
                P(1, :) = [PT(2,2), PT(1,1), slice];            
            else
                P(2, :) = [PT(2,2), PT(1,1), slice];            
            end
            set(fig, 'WindowButtonMotionFcn', @line);
            assignin('base', 'P', P);
            evalin('base', 'P');
                                    
            set(Line, 'Ydata', P(:,1));
            set(Line, 'Xdata', P(:,2));
                        
        end
    end

    function endMove(varargin)
        set(fig, 'WindowButtonMotionFcn', '');
        if mode == 1
            slice = newslice;
        end
    end

    function move(varargin)
        Q= get(fig, 'CurrentPoint');
        delta = xstart-Q(2);
        newslice = slice+round(delta/4);
        newslice = max(1, newslice);
        newslice = min(nslices, newslice);
        set(img, 'Cdata', V(:,:,newslice));
        set(fig, 'name', sprintf('Slice: %d / %d', newslice, nslices));
    end

    function line(varargin)
        
    end

    function modeSwitch(varargin)        
        mode = varargin{2}.Key;
        mode = str2num(mode);
        set(fig, 'name', sprintf('Mode: %d slide: %d', mode, slice));
    end

end

